"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _tagGettext = _interopRequireDefault(require("./tag-gettext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var NAME = 'jsxtag-gettext';

function match(node, context) {
  return t.isTaggedTemplateExpression(node) && context.hasAliasForFunc(NAME, node.tag.name);
}

function templateLiteral2Array(_ref) {
  var quasis = _ref.quasis,
      expressions = _ref.expressions;
  var items = [];
  quasis.forEach(function (quasi, i) {
    if (quasi.value.cooked !== '') {
      items.push(t.stringLiteral(quasi.value.cooked));
    }

    if (expressions[i]) {
      items.push(expressions[i]);
    }
  });
  return items;
}

function resolveDefault(node, context) {
  var resolved = _tagGettext.default.resolveDefault(node, context);

  if (t.isTemplateLiteral(resolved)) {
    return t.arrayExpression(templateLiteral2Array(resolved));
  }

  return t.arrayExpression([resolved]);
}

function resolve(node, translation, context) {
  var resolved = _tagGettext.default.resolve(node, translation, context);

  if (t.isTemplateLiteral(resolved)) {
    return t.arrayExpression(templateLiteral2Array(resolved));
  }

  return t.arrayExpression([resolved]);
}

var _default = _objectSpread({}, _tagGettext.default, {
  resolve: resolve,
  resolveDefault: resolveDefault,
  match: match,
  name: NAME
});

exports.default = _default;