"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _babelPluginMacros = require("babel-plugin-macros");

var _defaults = require("./defaults");

var _plugin = _interopRequireWildcard(require("./plugin"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function ttagMacro(_ref) {
  var references = _ref.references,
      state = _ref.state,
      t = _ref.babel.types,
      _ref$config = _ref.config,
      config = _ref$config === void 0 ? {} : _ref$config;
  var babelPluginTtag = (0, _plugin.default)();

  if ((0, _plugin.isStarted)()) {
    return {
      keepImports: true
    };
  }

  var program = state.file.path; // replace `babel-plugin-ttag/macro` by `ttag`, add create a node for ttag's imports

  var imports = t.importDeclaration([], t.stringLiteral('ttag')); // then add it to top of the document

  program.node.body.unshift(imports); // references looks like:
  // { default: [path, path], t: [path], ... }

  Object.keys(references).forEach(function (refName) {
    if (!_defaults.ALIAS_TO_FUNC_MAP[refName]) {
      var allowedMethods = Object.keys(_defaults.FUNC_TO_ALIAS_MAP).map(function (k) {
        var funcName = _defaults.FUNC_TO_ALIAS_MAP[k];
        return Array.isArray(funcName) ? funcName.join(', ') : funcName;
      });
      throw new _babelPluginMacros.MacroError("Invalid import: ".concat(refName, ". You can only import ").concat(allowedMethods.join(', '), " from 'babel-plugin-ttag/dist/ttag.macro'."));
    } // generate new identifier and add to imports


    var id;

    if (refName === 'default') {
      id = program.scope.generateUidIdentifier('ttag');
      imports.specifiers.push(t.importDefaultSpecifier(id));
    } else {
      id = program.scope.generateUidIdentifier(refName);
      imports.specifiers.push(t.importSpecifier(id, t.identifier(refName)));
    } // update references with the new identifiers


    references[refName].forEach(function (referencePath) {
      referencePath.node.name = id.name;
    });
  }); // apply babel-plugin-ttag to the file

  var stateWithOpts = _objectSpread({}, state, {
    opts: config
  });

  program.traverse(babelPluginTtag.visitor, stateWithOpts);
  return {};
}

var _default = (0, _babelPluginMacros.createMacro)(ttagMacro, {
  configName: 'ttag'
});

exports.default = _default;